import javax.swing.*;
import javax.swing.text.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;
import java.util.*;
import java.util.Calendar;
import java.text.SimpleDateFormat;

public class AnimalApp extends JFrame implements ActionListener, MouseListener
{
	//Semua kelas seperti ProtozoaClass, PoriferaClass, ...
	//di-inisialisasikan langsung di prosedur searchActionPerformed(ActionEvent evt)
	//jadi tidak dideklarasikan di variabel bebas.
	
	private JFileChooser choose = new JFileChooser();
	
	private JMenuBar jMenuBar = new JMenuBar();
	private JMenu menuFile, menuEdit, menuHelp;
	private JMenuItem New, exit, save, menuContent, aboutUs;
	private JCheckBoxMenuItem wordWrap;
	
	private JToolBar jToolBar = new JToolBar();
	private JButton NewB, SaveB, LogOfB, ShutdownB, RestartB;
	
	private JLabel l1, l2, l3;
	private JTextField tf;
	
	private JComboBox cb, cb2;
	
	private JRadioButton rb1, rb2;
	private ButtonGroup bg;
	
	private JButton search;
	private JButton [] theme = new JButton [4];
	
	private JTextArea ta, fungsi;
	private JScrollPane sp;
	
	JLabel preview = new JLabel();
	JLabel image = new JLabel(new ImageIcon("images/null.gif"));
	JLabel credit = new JLabel(new ImageIcon("images/credit.gif"));
	JLabel lblFungsi = new JLabel("Control Function : ");
	
	public AnimalApp()
	{
		//membuat filter untuk save file, dimana hanya ditampilkan *.doc, *.java, dan *.txt
		choose.addChoosableFileFilter(new DokumenFilterClass(".txt", "File Dokumen (*.txt)"));
		choose.addChoosableFileFilter(new DokumenFilterClass(".java", "File Dokumen (*.java)"));
		choose.addChoosableFileFilter(new DokumenFilterClass(".doc", "File Dokumen (*.doc)"));
				
		menuFile = new JMenu("File");
		menuFile.setMnemonic('F');
		New = new JMenuItem("New", new ImageIcon("images/new.png"));
		New.setMnemonic('N');
		New.addActionListener(this);
		
		save = new JMenuItem("Save", new ImageIcon("images/save.gif"));
		save.setMnemonic('s');
		save.addActionListener(new ActionListener() 
		{
            public void actionPerformed(ActionEvent evt) 
            {
                saveActionPerformed(evt);
            }
        });
        
		exit = new JMenuItem("Exit");
		exit.setMnemonic('x');
		exit.addActionListener(new ActionListener() 
		{
            public void actionPerformed(ActionEvent evt) 
            {
                exitActionPerformed(evt);
            }
        });
        menuFile.add(New);
        menuFile.add(save);
		menuFile.add(exit);
		
		menuEdit = new JMenu("Format");
		menuEdit.setMnemonic('o');
		wordWrap = new JCheckBoxMenuItem("Word Wrap");
		wordWrap.setMnemonic('w');
		wordWrap.addActionListener(new ActionListener() 
		{
            public void actionPerformed(ActionEvent evt) 
            {
                wordWrapActionPerformed(evt);
            }
        });
		menuEdit.add(wordWrap);
		
		menuHelp = new JMenu("Help");
		
		menuContent = new JMenuItem("Help Content");
		menuContent.addActionListener(this);
		menuContent.setMnemonic('C');
		menuHelp.add(menuContent);
		
		aboutUs = new JMenuItem("About Us");
		aboutUs.addActionListener(this);
		aboutUs.setMnemonic('b');
		menuHelp.add(aboutUs);
		
		menuHelp.setMnemonic('H');
		
		jMenuBar.setSize(jMenuBar.getPreferredSize());
		jMenuBar.add(menuFile);
		jMenuBar.add(menuEdit);
		jMenuBar.add(menuHelp);
		
		
		NewB = new JButton("New", new ImageIcon("images/new.png"));
		NewB.setSize(NewB.getPreferredSize());
		NewB.setMnemonic('N');
		NewB.setOpaque(false);
		NewB.addActionListener(this);
		NewB.addMouseListener(this);
		
		SaveB = new JButton("Save",new ImageIcon("images/save.gif"));
		SaveB.setSize(SaveB.getPreferredSize());
		SaveB.setMnemonic('S');
		SaveB.setOpaque(false);
		SaveB.addActionListener(this);
		SaveB.addMouseListener(this);
		SaveB.setRolloverIcon(new ImageIcon("images/Untitled-1.gif"));
		
		LogOfB = new JButton("Log off", new ImageIcon("images/logoff.gif"));
		LogOfB.setPressedIcon(new ImageIcon("images/logoff.gif"));
		LogOfB.setMnemonic('L');
		LogOfB.setOpaque(false);
		LogOfB.addActionListener(this);
		LogOfB.addMouseListener(this);
		
		ShutdownB = new JButton("Shutdown", new ImageIcon("images/shutdown.gif"));
		ShutdownB.setPressedIcon(new ImageIcon("images/shutdown.gif"));
		ShutdownB.setMnemonic('u');
		ShutdownB.setOpaque(false);
		ShutdownB.addActionListener(this);
		ShutdownB.addMouseListener(this);
		
		RestartB = new JButton("Restart", new ImageIcon("images/restart.gif"));
		RestartB.setPressedIcon(new ImageIcon("images/restart.gif"));
		RestartB.setMnemonic('R');
		RestartB.setOpaque(false);
		RestartB.addActionListener(this);
		RestartB.addMouseListener(this);
		
		jToolBar.setLayout(new GridLayout(1,5));
		jToolBar.add(NewB);
		jToolBar.add(SaveB);
		jToolBar.add(LogOfB);
		jToolBar.add(ShutdownB);
		jToolBar.add(RestartB);
		jToolBar.setSize(jToolBar.getPreferredSize());
		
		l1 = new JLabel("1. Masukkan nama Hewan :");
		l1.setSize(l1.getPreferredSize());
		l1.setLocation(10,50);
		l1.addMouseListener(this);
		
		l2 = new JLabel("2. Pilih Sub Filum Hewan :");
		l2.setSize(l2.getPreferredSize());
		l2.setLocation(10,80);
		l2.addMouseListener(this);
		
		l3 = new JLabel("3. Pilih Sub Kelas Hewan :");
		l3.setSize(l3.getPreferredSize());
		l3.setLocation(10,110);
		l3.addMouseListener(this);
		
		//membuat JTextField hanya dapat dimasukkan huruf
		PlainDocument wordOnly = new PlainDocument()
		{
			public void insertString(int offs, String str, AttributeSet a) throws BadLocationException
			{
				char ch = str.charAt(0);
				if(Character.isLetter(ch) || Character.isSpace(ch))
				{
					super.insertString(offs,str,a);
				}
			}
		};
		
		tf = new JTextField(16);
		tf.setDocument(wordOnly);
		tf.setNextFocusableComponent(search);
		tf.setSize(tf.getPreferredSize());
		tf.setLocation(210,50);
		tf.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
		tf.addMouseListener(this);
		tf.addActionListener(new ActionListener() 
		{
            public void actionPerformed(ActionEvent evt) 
            {
                tfActionPerformed(evt);
            }
        });
		tf.addKeyListener(new KeyAdapter() 
		{
            public void keyReleased(KeyEvent evt) 
            {
                tfKeyReleased(evt);
          	}
        });
		
		cb = new JComboBox();
		cb.setSize(tf.getPreferredSize());
		cb.setLocation(210,50);
		cb.addActionListener(new ActionListener() 
		{
            public void actionPerformed(ActionEvent evt) 
            {
                cbActionPerformed(evt);
            }
        });
        
        cb2 = new JComboBox();
		cb2.setSize(tf.getPreferredSize());
		cb2.setLocation(210,110);
		cb2.setEnabled(false);
		cb2.addMouseListener(this);
		
        
        rb1 = new JRadioButton("Invertebrata", new ImageIcon("images/rb.gif")); 
        rb1.setSize(rb1.getPreferredSize());
        rb1.setLocation(205,76);
 		rb1.setPressedIcon(new ImageIcon("images/rbp.gif")); 
 		rb1.setRolloverIcon(new ImageIcon("images/rbr.gif")); 
 		rb1.setRolloverSelectedIcon(new ImageIcon("images/rbrs.gif")); 
 		rb1.setSelectedIcon(new ImageIcon("images/rbs.gif")); 
        rb1.setEnabled(false);
        rb1.addMouseListener(this);
        rb1.addActionListener(new ActionListener() 
        {
            public void actionPerformed(ActionEvent evt) 
            {
                rb1ActionPerformed(evt);
            }
        });
        
        rb2 = new JRadioButton("Vertebrata", new ImageIcon("images/rb.gif")); 
        rb2.setSize(rb2.getPreferredSize());
        rb2.setLocation(305,76);
        rb2.setPressedIcon(new ImageIcon("images/rbp.gif")); 
 		rb2.setRolloverIcon(new ImageIcon("images/rbr.gif")); 
 		rb2.setRolloverSelectedIcon(new ImageIcon("images/rbrs.gif")); 
 		rb2.setSelectedIcon(new ImageIcon("images/rbs.gif")); 
        rb2.setEnabled(false);
        rb2.addMouseListener(this);
        rb2.addActionListener(new ActionListener() 
        {
            public void actionPerformed(ActionEvent evt) 
            {
                rb2ActionPerformed(evt);
            }
        });
        
        bg = new ButtonGroup();
        bg.add(rb1);
		bg.add(rb2);
		
		search = new JButton("Search", new ImageIcon("images/searchicon.gif"));
		search.setSize(search.getPreferredSize());
		search.setLocation(160,140);
		search.setOpaque(false);
		search.addMouseListener(this);
		search.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent evt)
			{
				searchActionPerformed(evt);
			}
		});
		
		preview.setText("Animal Example");
		preview.setHorizontalAlignment(javax.swing.JTextField.CENTER);
		preview.setForeground(Color.BLUE);
		preview.setSize(200,20);
		preview.setLocation(420,180);
		preview.addMouseListener(this);
		
		image.setSize(200,160);
		image.setLocation(420,210);
		image.setBackground(new Color(0,0,0));
		image.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
		image.addMouseListener(this);
		
		//membuat button theme JTextArea
		for(int i=0; i<4; i++)
		{
			theme[i] = new JButton("Theme "+(i+1));
			theme[i].setSize(theme[i].getPreferredSize());
			theme[i].setOpaque(false);
			theme[i].addActionListener(this);
			theme[i].addMouseListener(this);
		}
		
		theme[0].setLocation(33,180);
		theme[1].setLocation(123,180);
		theme[2].setLocation(213,180);
		theme[3].setLocation(303,180);
		
		
		//membuat komponen display informasi
		ta = new JTextArea();
		ta.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
		ta.setBackground(Color.BLUE);
		ta.setForeground(Color.WHITE);
		ta.setEditable(false);
		ta.addMouseListener(this);
		
		sp = new JScrollPane();
		sp.getViewport().add(ta);
		sp.getViewport().setOpaque(false);
		sp.setOpaque(false);
		sp.setSize(380,160);
		sp.setLocation(20,210);
		
		
		//menampilkan credit
		credit.setSize(200,125);
		credit.setLocation(420,50);
		credit.setBackground(new Color(0,0,0));
		credit.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
		credit.addMouseListener(this);
		
		
		//membuat JTextField untuk info fungsi
		fungsi = new JTextArea();
		fungsi.setRows(2);
		fungsi.setSize(440,40);
		fungsi.setLineWrap(true);
		fungsi.setEditable(false);
		fungsi.setLocation(120,400);
		fungsi.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
		fungsi.addMouseListener(this);
		
		//membuat JLabel untuk label fungsi
		lblFungsi.setLocation(10,400);
		lblFungsi.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
		lblFungsi.setSize(lblFungsi.getPreferredSize());
		lblFungsi.addMouseListener(this);
	}
	
	private void searchActionPerformed(ActionEvent evt)
	{
		Calendar now = Calendar.getInstance();
	    SimpleDateFormat formatter = new SimpleDateFormat("E dd.MM.yyyy 'at' hh:mm:ss a zzz");
	    
		if(tf.getText().length()<=0 || (rb1.isSelected() == false && rb2.isSelected() == false))
		{
			JOptionPane.showMessageDialog(null,"Maaf data Anda masih kurang! Coba Periksa lagi!");
		}
		else
		{
			if(cb2.getSelectedItem().equals("Protozoa"))
			{
				ta.setBorder(javax.swing.BorderFactory.createTitledBorder(tf.getText()+ " (Protozoa) "+formatter.format(now.getTime())));
				ta.setText(new ProtozoaClass().getInfo());
				image.setIcon(new ImageIcon("images/Protozoa.jpg"));
				preview.setText("Protozoa Example");
			}
			else if(cb2.getSelectedItem().equals("Porifera"))
			{
				ta.setBorder(javax.swing.BorderFactory.createTitledBorder(tf.getText()+ " (Porifera) "+formatter.format(now.getTime())));
				ta.setText(new PoriferaClass().getInfo());
				image.setIcon(new ImageIcon("images/Porifera.jpg"));
				preview.setText("Porifera Example");
			}
			else if(cb2.getSelectedItem().equals("Coelenterata"))
			{
				ta.setBorder(javax.swing.BorderFactory.createTitledBorder(tf.getText()+ " (Coelenterata) "+formatter.format(now.getTime())));
				ta.setText(new CoelenterataClass().getInfo());
				image.setIcon(new ImageIcon("images/Coelenterata.jpg"));
				preview.setText("Coelenterata Example");
			}
			else if(cb2.getSelectedItem().equals("Plathyhelminthes"))
			{
				ta.setBorder(javax.swing.BorderFactory.createTitledBorder(tf.getText()+ " (Plathyhelminthes) "+formatter.format(now.getTime())));
				ta.setText(new PlathyhelminthesClass().getInfo());
				image.setIcon(new ImageIcon("images/Plathyhelminthes.jpg"));
				preview.setText("Plathyhelminthes Example");
			}
			else if(cb2.getSelectedItem().equals("Nemathelminthes"))
			{
				ta.setBorder(javax.swing.BorderFactory.createTitledBorder(tf.getText()+ " (Nemathelminthes) "+formatter.format(now.getTime())));
				ta.setText(new NemathelminthesClass().getInfo());
				image.setIcon(new ImageIcon("images/Nemathelminthes.jpg"));
				preview.setText("Nemathelminthes Example");
			}
			else if(cb2.getSelectedItem().equals("Annelida"))
			{
				ta.setBorder(javax.swing.BorderFactory.createTitledBorder(tf.getText()+ " (Annelida) "+formatter.format(now.getTime())));
				ta.setText(new AnnelidaClass().getInfo());
				image.setIcon(new ImageIcon("images/Annelida.jpg"));
				preview.setText("Annelida Example");
			}
			else if(cb2.getSelectedItem().equals("Mollusca"))
			{
				ta.setBorder(javax.swing.BorderFactory.createTitledBorder(tf.getText()+ " (Mollusca) "+formatter.format(now.getTime())));
				ta.setText(new MolluscaClass().getInfo());
				image.setIcon(new ImageIcon("images/Mollusca.jpg"));
				preview.setText("Mollusca Example");
			}
			else if(cb2.getSelectedItem().equals("Arthropoda"))
			{
				ta.setBorder(javax.swing.BorderFactory.createTitledBorder(tf.getText()+ " (Arthropoda) "+formatter.format(now.getTime())));
				ta.setText(new ArthropodaClass().getInfo());
				image.setIcon(new ImageIcon("images/Arthropoda.jpg"));
				preview.setText("Arthropoda Example");
			}
			else if(cb2.getSelectedItem().equals("Echinodermata"))
			{
				ta.setBorder(javax.swing.BorderFactory.createTitledBorder(tf.getText()+ " (Echinodermata) "+formatter.format(now.getTime())));
				ta.setText(new EchinodermataClass().getInfo());
				image.setIcon(new ImageIcon("images/Echinodermata.jpg"));
				preview.setText("Echinodermata Example");
			}
			else if(cb2.getSelectedItem().equals("Pisces"))
			{
				ta.setBorder(javax.swing.BorderFactory.createTitledBorder(tf.getText()+ " (Pisces) "+formatter.format(now.getTime())));
				ta.setText(new PiscesClass().getInfo());
				image.setIcon(new ImageIcon("images/Pisces.jpg"));
				preview.setText("Pisces Example");
			}
			else if(cb2.getSelectedItem().equals("Amphibia"))
			{
				ta.setBorder(javax.swing.BorderFactory.createTitledBorder(tf.getText()+ " (Amphibia) "+formatter.format(now.getTime())));
				ta.setText(new AmphibiaClass().getInfo());
				image.setIcon(new ImageIcon("images/Amphibia.jpg"));
				preview.setText("Amphibia Example");
			}
			else if(cb2.getSelectedItem().equals("Reptilia"))
			{
				ta.setBorder(javax.swing.BorderFactory.createTitledBorder(tf.getText()+ " (Reptilia) "+formatter.format(now.getTime())));
				ta.setText(new ReptiliaClass().getInfo());
				image.setIcon(new ImageIcon("images/Reptilia.jpg"));
				preview.setText("Reptilia Example");
			}
			else if(cb2.getSelectedItem().equals("Aves"))
			{
				ta.setBorder(javax.swing.BorderFactory.createTitledBorder(tf.getText()+ " (Aves) "+formatter.format(now.getTime())));
				ta.setText(new AvesClass().getInfo());
				image.setIcon(new ImageIcon("images/Aves.jpg"));
				preview.setText("Aves Example");
			}
			else if(cb2.getSelectedItem().equals("Mamalia"))
			{
				ta.setBorder(javax.swing.BorderFactory.createTitledBorder(tf.getText()+ " (Mamalia) "+formatter.format(now.getTime())));
				ta.setText(new MamaliaClass().getInfo());
				image.setIcon(new ImageIcon("images/Mamalia.jpg"));
				preview.setText("Mamalia Example");
			}
		}
	}
	
	private void newFile()
	{
		if(ta.getText().length()>0)
		{
			int simpan = JOptionPane.showConfirmDialog(this, "Anda ingin menyimpan info?","Animal Kingdom Dictionary",JOptionPane.YES_NO_CANCEL_OPTION);
	        if (simpan == JOptionPane.YES_OPTION) 
	        {
	        	save();
	        } 
		}
		tf.setText("");
    	bg.clearSelection();	
    	rb1.setEnabled(false);
    	rb2.setEnabled(false);	
    	cb2.removeAllItems();
    	cb2.setEnabled(false);
    	image.setIcon(new ImageIcon("images/null.gif"));
    	ta.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
    	ta.setText("");
	}
	
	private void save() 
    {       
     	boolean kondisi = false;
     	if(ta.getText().length()>0)
     	{
     		int result = choose.showSaveDialog(null);
			if(result == JFileChooser.APPROVE_OPTION)
			{
				String file = choose.getSelectedFile().toString();
				File fileteks;
				if(file.toLowerCase().endsWith(".doc") || file.toLowerCase().endsWith(".java") || file.toLowerCase().endsWith(".txt"))
				{
					fileteks = new File(file);
				}
				else
				{
					fileteks = new File(file+".txt");
				}
				
				try
				{
					
					if(fileteks.exists())
					{
						kondisi = true;
					}
					else
					{
						fileteks.createNewFile();
					}
					
					PrintWriter fileoutput = new PrintWriter (new FileWriter (fileteks.getPath(),kondisi));
					
					Calendar now = Calendar.getInstance();
		        	SimpleDateFormat formatter = new SimpleDateFormat("E dd.MM.yyyy 'at' hh:mm:ss a zzz");
		        	
		        	fileoutput.println(formatter.format(now.getTime()));
		        	fileoutput.println();
		        	fileoutput.println(tf.getText());
					String [] identitas = ta.getText().split("\n");
					
					for(int i=0; i<identitas.length; i++)
					{
						fileoutput.println(identitas[i]);
					}
					fileoutput.println();
					fileoutput.println();
					fileoutput.close();
					JOptionPane.showMessageDialog(null,fileteks.getAbsoluteFile().toString());
				}
				
				catch(Exception e)
				{
					System.out.println("Error");
				}
     		}
		}
		else
		{
			JOptionPane.showMessageDialog(null,"Maaf! Anda belum memiliki info yang dapat di save.");
		}
		
    }
    
    private void saveActionPerformed(ActionEvent evt) 
    {       
    	save(); 		
	}
	
	private void exitActionPerformed(ActionEvent evt) 
    {
    	//mengkonfirmasi apakah data akan di save
    	if(ta.getText().length()>0)
		{
			int simpan = JOptionPane.showConfirmDialog(this, "Anda ingin menyimpan info?","Animal Kingdom Dictionary",JOptionPane.YES_NO_CANCEL_OPTION);
	        if (simpan == JOptionPane.YES_OPTION) 
	        {
	        	save();
	        } 
		}
		
		//konfirmasi apakah user ingin keluar       
     	int exit = JOptionPane.showConfirmDialog(this, "Apakah Anda Yakin Ingin Keluar?","Animal Kingdom Dictionary",JOptionPane.YES_NO_CANCEL_OPTION);
        if (exit == JOptionPane.YES_OPTION) 
        {
        	animasiClose();
         	System.exit(0);
        } 
    }
    
    private void wordWrapActionPerformed(ActionEvent evt) 
    {       
     	if(wordWrap.isSelected())
     	{
     		ta.setLineWrap(true);
     	}
     	else
     	{
     		ta.setLineWrap(false);
     	}
    }
	
	private void tfActionPerformed(ActionEvent evt) 
    {       
    	Calendar now = Calendar.getInstance();
	    SimpleDateFormat formatter = new SimpleDateFormat("E dd.MM.yyyy 'at' hh:mm:ss a zzz");
	    
     	cb.hidePopup();
     	
     	//mengelompokkan jenis pisces
     	Vector vPisces = new Vector();
     	vPisces.add("bawal");
     	vPisces.add("dumbo");
     	vPisces.add("ikan");
     	vPisces.add("lele");
     	vPisces.add("gurame");
     	vPisces.add("nila");
     	vPisces.add("nest");
     	vPisces.add("mujair");
     	vPisces.add("ikan mas");
     	vPisces.add("arwana");
     	vPisces.add("sepat");
     	vPisces.add("patin");
     	
     	//mengelompokkan jenis amphibi
     	Vector vAmphibi = new Vector();
     	vAmphibi.add("katak");
     	vAmphibi.add("kodok");
     	
     	//mengelompokkan jenis reptil
     	Vector vReptil = new Vector();
     	vReptil.add("cicak");
     	vReptil.add("ular");
     	vReptil.add("salamander");
     	vReptil.add("boa");
     	vReptil.add("anaconda");
     	vReptil.add("cobra");
     	vReptil.add("phyton");
     	vReptil.add("kadal");
     	vReptil.add("komodo");
     	vReptil.add("bunglon");
     	vReptil.add("buaya");
     	vReptil.add("biawak");
     	
     	//mengelompokkan jenis aves
     	Vector vAves = new Vector();
     	vAves.add("angsa");
     	vAves.add("anoa");
     	vAves.add("ayam");
     	vAves.add("burung");
     	vAves.add("bangau");
     	vAves.add("cendrawasih");
     	vAves.add("capung");
     	vAves.add("elang");
     	vAves.add("entok");
     	vAves.add("garuda");
     	vAves.add("itik");
     	vAves.add("merpati");
     	vAves.add("parkit");
     	vAves.add("unggas");
     	
     	//mengelompokkan jenis mamalia
     	Vector vMamalia = new Vector();
     	vMamalia.add("anjing");
     	vMamalia.add("banteng");
     	vMamalia.add("badak");
     	vMamalia.add("domba");
     	vMamalia.add("dongala");
     	vMamalia.add("gajah");
     	vMamalia.add("harimau");
     	vMamalia.add("hiu");
     	vMamalia.add("kancil");
     	vMamalia.add("keledai");
     	vMamalia.add("kerbau");
     	vMamalia.add("kuda");  
     	vMamalia.add("lembu");     	
     	vMamalia.add("sapi");
     	vMamalia.add("zebra");
     	vMamalia.add("zerapah");
     	
     	//mengelompokkan protozoa
     	Vector vProtozoa = new Vector();
     	vProtozoa.add("amuba");
     	
     	if(vPisces.contains(tf.getText().toLowerCase()))
     	{
     		rb2.setEnabled(true);
     		rb2.setSelected(true);
     		cb2.setEnabled(true);
     		cb2.setModel(new DefaultComboBoxModel(new String[] { "Pisces", "Amphibia", "Reptilia", "Aves", "Mamalia" }));
     		cb2.setSelectedItem("Pisces");
     		ta.setBorder(javax.swing.BorderFactory.createTitledBorder(tf.getText()+ " (Pisces) "+formatter.format(now.getTime())));
     		ta.setText(new PiscesClass().getInfo());
     		image.setIcon(new ImageIcon("images/Pisces.jpg"));
			preview.setText("Pisces Example");
     	}
     	else if(vAmphibi.contains(tf.getText().toLowerCase()))
     	{
     		rb2.setEnabled(true);
     		rb2.setSelected(true);
     		cb2.setEnabled(true);
     		cb2.setModel(new DefaultComboBoxModel(new String[] { "Pisces", "Amphibia", "Reptilia", "Aves", "Mamalia" }));
     		cb2.setSelectedItem("Amphibia");
     		ta.setBorder(javax.swing.BorderFactory.createTitledBorder(tf.getText()+ " (Amphibia) "+formatter.format(now.getTime())));
     		ta.setText(new AmphibiaClass().getInfo());
     		image.setIcon(new ImageIcon("images/Amphibia.jpg"));
			preview.setText("Amphibia Example");
     	}
     	else if(vReptil.contains(tf.getText().toLowerCase()))
     	{
     		rb2.setEnabled(true);
     		rb2.setSelected(true);
     		cb2.setEnabled(true);
     		cb2.setModel(new DefaultComboBoxModel(new String[] { "Pisces", "Amphibia", "Reptilia", "Aves", "Mamalia" }));
     		cb2.setSelectedItem("Reptilia");
     		ta.setBorder(javax.swing.BorderFactory.createTitledBorder(tf.getText()+ " (Reptilia) "+formatter.format(now.getTime())));
     		ta.setText(new ReptiliaClass().getInfo());
     		image.setIcon(new ImageIcon("images/Reptilia.jpg"));
			preview.setText("Reptilia Example");
     	}
     	else if(vAves.contains(tf.getText().toLowerCase()))
     	{
     		rb2.setEnabled(true);
     		rb2.setSelected(true);
     		cb2.setEnabled(true);
     		cb2.setModel(new DefaultComboBoxModel(new String[] { "Pisces", "Amphibia", "Reptilia", "Aves", "Mamalia" }));
     		cb2.setSelectedItem("Aves");
     		ta.setBorder(javax.swing.BorderFactory.createTitledBorder(tf.getText()+ " (Aves) "+formatter.format(now.getTime())));
     		ta.setText(new AvesClass().getInfo());
     		image.setIcon(new ImageIcon("images/Aves.jpg"));
			preview.setText("Aves Example");
     	}
     	else if(vMamalia.contains(tf.getText().toLowerCase()))
     	{
     		rb2.setEnabled(true);
     		rb2.setSelected(true);
     		cb2.setEnabled(true);
     		cb2.setModel(new DefaultComboBoxModel(new String[] { "Pisces", "Amphibia", "Reptilia", "Aves", "Mamalia" }));
     		cb2.setSelectedItem("Mamalia");
     		ta.setBorder(javax.swing.BorderFactory.createTitledBorder(tf.getText()+ " (Mamalia) "+formatter.format(now.getTime())));
     		ta.setText(new MamaliaClass().getInfo());
     		image.setIcon(new ImageIcon("images/Mamalia.jpg"));
			preview.setText("Mamalia Example");
     	}
     	else if(vProtozoa.contains(tf.getText().toLowerCase()))
     	{
     		rb1.setEnabled(true);
     		rb1.setSelected(true);
     		cb2.setEnabled(true);
     		cb2.setModel(new DefaultComboBoxModel(new String[] { "Protozoa", "Porifera", "Coelenterata", "Plathyhelminthes", "Nemathelminthes", "Annelida", "Mollusca", "Arthropoda", "Echinodermata" }));
     		cb2.setSelectedItem("Protozoa");
     		ta.setBorder(javax.swing.BorderFactory.createTitledBorder(tf.getText()+ " (Protozoa) "+formatter.format(now.getTime())));
     		ta.setText(new ProtozoaClass().getInfo());
     		image.setIcon(new ImageIcon("images/Protozoa.jpg"));
			preview.setText("Protozoa Example");
     	}
     	
    }
	
	private void tfKeyReleased(KeyEvent evt) 
	{  
        cb.hidePopup();
        cb.removeAllItems();
        String s = tf.getText();
        
        if(evt.getKeyCode() != KeyEvent.VK_ENTER)
        {
        	if(tf.getText().toLowerCase().startsWith("a"))
	        {
	        	cb.addItem("Amuba");
	        	cb.addItem("Anaconda");
	            cb.addItem("Angsa");
	            cb.addItem("Anjing");
	            cb.addItem("Anoa");
	            cb.addItem("Arwana");
	            cb.addItem("Ayam");	   
	        }
	        else if(tf.getText().toLowerCase().startsWith("b"))
	        {
	            cb.addItem("Badak");
	            cb.addItem("Bawal");
	            cb.addItem("Bangau");
	            cb.addItem("Banteng");
	            cb.addItem("Beruang");
	            cb.addItem("Biawak");
	            cb.addItem("Buaya");
	            cb.addItem("Bunglon");
	            cb.addItem("Burung");
	            cb.addItem("boa");           
	        }
	        else if(tf.getText().toLowerCase().startsWith("c"))
	        {
	        	cb.addItem("Capung");
	        	cb.addItem("Cendrawasih");
	            cb.addItem("Cicak");
	            cb.addItem("Cobra");	            
	        }
	        else if(tf.getText().toLowerCase().startsWith("d"))
	        {
	        	cb.addItem("Dongala");
	        	cb.addItem("Domba");
	        	cb.addItem("Dumbo");	        	
	        }
	        else if(tf.getText().toLowerCase().startsWith("e"))
	        {
	            cb.addItem("Elang");
	            cb.addItem("Entok");
	        }
	        else if(tf.getText().toLowerCase().startsWith("g"))
	        {
	            cb.addItem("Gajah");
	            cb.addItem("Garuda");
	            cb.addItem("Gurame");
	        }
	        else if(tf.getText().toLowerCase().startsWith("h"))
	        {
	            cb.addItem("Harimau");
	            cb.addItem("Hiu");
	        }
	        else if(tf.getText().toLowerCase().startsWith("i"))
	        {
	            cb.addItem("Ikan");
	            cb.addItem("Ikan Mas");
	            cb.addItem("Itik");
	        }
	        else if(tf.getText().toLowerCase().startsWith("k"))
	        {
	            cb.addItem("Katak");
	            cb.addItem("Kodok");
	            cb.addItem("Kadal");
	            cb.addItem("Komodo");
	            cb.addItem("Kancil");
	            cb.addItem("Keledai");
	            cb.addItem("Kerbau");
	            cb.addItem("Kuda");	           
	        }
	        else if(tf.getText().toLowerCase().startsWith("l"))
	        {
	            cb.addItem("Lele");
	            cb.addItem("Lembu");	            
	        }
	        else if(tf.getText().toLowerCase().startsWith("m"))
	        {
	            cb.addItem("Mujair");
	            cb.addItem("Merpati");	            
	        }
	        else if(tf.getText().toLowerCase().startsWith("n"))
	        {
	            cb.addItem("Nila");
	            cb.addItem("Nest");	            
	        }
	        else if(tf.getText().toLowerCase().startsWith("p"))
	        {
	            cb.addItem("Patin");
	            cb.addItem("Phyton");
	            cb.addItem("Parkit");
	        }
	        else if(tf.getText().toLowerCase().startsWith("s"))
	        {
	            cb.addItem("Sepat");
	            cb.addItem("Salamander");
	            cb.addItem("Sapi");
	        }
	        else if(tf.getText().toLowerCase().startsWith("u"))
	        {
	            cb.addItem("Ular");
	            cb.addItem("Unggas");
	        }
	        else if(tf.getText().toLowerCase().startsWith("z"))
	        {
	            cb.addItem("Zebra");
	            cb.addItem("Zerapah");
	        }
	        	
			cb.setMaximumRowCount(cb.getItemCount());
	        cb.showPopup();	        	
        }
        
        tf.setText(s);
        
        
        if(tf.getText().length()>0)
        {
        	rb1.setEnabled(true);
        	rb2.setEnabled(true);
        	
        	if(rb1.isSelected() || rb2.isSelected())
        	{
        		cb2.setEnabled(true);
        	}
        	
        	if(evt.getKeyCode() == KeyEvent.VK_DOWN)
        	{
        		cb.requestFocus();	
        	}
        }
        else
        {
        	rb1.setEnabled(false);
        	rb2.setEnabled(false);
        	cb2.setEnabled(false);
        }
        
    }
    
  	private void cbActionPerformed(ActionEvent evt) 
    {
    	try
    	{
    		tf.setText(cb.getSelectedItem().toString());	
    	}
    	catch(NullPointerException npe)
    	{
    	}   
    }
    
    private void rb1ActionPerformed(ActionEvent evt) 
    {
    	try
    	{
    		tf.setText(cb.getSelectedItem().toString());	
    	}
    	catch(NullPointerException npe)
    	{
    	}
    	
		cb2.removeAllItems();
		cb2.setModel(new DefaultComboBoxModel(new String[] { "Protozoa", "Porifera", "Coelenterata", "Plathyhelminthes", "Nemathelminthes", "Annelida", "Mollusca", "Arthropoda", "Echinodermata" }));
		cb2.setEnabled(true);
		
    }
    
    private void rb2ActionPerformed(ActionEvent evt) 
    {
    	try
    	{
    		tf.setText(cb.getSelectedItem().toString());	
    	}
    	catch(NullPointerException npe)
    	{
    	}
    	
		cb2.removeAllItems();
		cb2.setModel(new DefaultComboBoxModel(new String[] { "Pisces", "Amphibia", "Reptilia", "Aves", "Mamalia" }));
		cb2.setEnabled(true);
    }
	
	private void showGUI()
	{
		this.setTitle("Animal Kingdom Dictionary");
		this.setDefaultCloseOperation(2);
		this.setSize(650,510);
		this.setLayout(null);
		this.setLocationRelativeTo(null);
		
		this.setJMenuBar(jMenuBar);
		
		this.add(jToolBar);
		
		this.getContentPane().add(l1);
		this.getContentPane().add(l2);
		this.getContentPane().add(l3);
		
		this.getContentPane().add(tf);
		
		this.getContentPane().add(cb);
		this.getContentPane().add(cb2);
		
		this.getContentPane().add(rb1);
		this.getContentPane().add(rb2);
		
		this.getContentPane().add(search);
		
		//menampilkan gambar
		this.getContentPane().add(preview);
		this.getContentPane().add(image);
		this.getContentPane().add(credit);
		
		//menampilkan button theme JTextArea
		for(int i=0; i<4; i++)
		{
			this.getContentPane().add(theme[i]);
		}
		
		//ta (JTextArea) tidak di add karena sudah tergabung di sp (JScrollPane)
		this.getContentPane().add(sp);
		
        //menampilkan JTextField info fungsi dan labelnya
        this.getContentPane().add(fungsi);
        this.getContentPane().add(lblFungsi);
        
        try
        {
        	UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        	SwingUtilities.updateComponentTreeUI(this);
        	SwingUtilities.updateComponentTreeUI(choose);
        }
        catch(Exception e)
        {
        }
        
		this.setVisible(true);
		
	}
	
	protected void processWindowEvent(WindowEvent e) 
	{
		if (e.getID() == WindowEvent.WINDOW_OPENED) 
        {
        	animasiOpen();
        }
        else if (e.getID() == WindowEvent.WINDOW_CLOSING) 
        {
        	if(ta.getText().length()>0)
			{
				int simpan = JOptionPane.showConfirmDialog(this, "Anda ingin menyimpan info?","Animal Kingdom Dictionary",JOptionPane.YES_NO_CANCEL_OPTION);
		        if (simpan == JOptionPane.YES_OPTION) 
		        {
		        	save();
		        } 
			}
            int exit = JOptionPane.showConfirmDialog(this, "Apakah Anda Yakin Ingin Keluar?","Animal Kingdom Dictionary",JOptionPane.YES_NO_CANCEL_OPTION);
	        if (exit == JOptionPane.YES_OPTION) 
	        {
	        	animasiClose();
	         	System.exit(0);
	        } 
            
        } 
        else 
        {
            super.processWindowEvent(e);
        }
    }
    
    public void actionPerformed(ActionEvent evt)
    {
    	Object btn = (Object) evt.getSource();
    	
    	if(btn == theme[0])
    	{
    		ta.setBackground(Color.BLUE);
    		ta.setForeground(Color.WHITE);
    	}
    	else if(btn == theme[1])
    	{
    		ta.setBackground(Color.WHITE);
    		ta.setForeground(Color.BLACK);
    	}
    	else if(btn == theme[2])
    	{
    		ta.setBackground(Color.RED);
    		ta.setForeground(Color.GREEN);
    	}
    	else if(btn == theme[3])
    	{
    		ta.setBackground(Color.GREEN);
    		ta.setForeground(Color.RED);
    	}
    	else if(btn == New)
    	{
    		newFile();
    	}
    	else if(btn == NewB)
    	{
    		newFile();
    	}
    	else if(btn == SaveB)
    	{
    		save();
    	}
    	else if(btn == LogOfB)
    	{
    		try
    		{
    			Runtime.getRuntime().exec("shutdown -l");
    		}
    		catch(Exception e)
    		{
    		}
    	}
    	else if(btn == ShutdownB)
    	{
    		JOptionPane.showMessageDialog(null, "Untuk membatalkan buka Command Prompt, lalu ketik shutdown -a.");
    		try
    		{
    			Runtime.getRuntime().exec("shutdown -s -t 30");
    		}
    		catch(Exception e)
    		{
    		}
    	}
    	else if(btn == RestartB)
    	{
    		JOptionPane.showMessageDialog(null, "Untuk membatalkan buka Command Prompt, lalu ketik shutdown -a.");
    		try
    		{
    			Runtime.getRuntime().exec("shutdown -r -t 30");
    		}
    		catch(Exception e)
    		{
    		}
    	}
    	else if(btn == menuContent)
    	{
    		JOptionPane.showMessageDialog(null,"You must register this application to enter this content!","Please Register!",JOptionPane.INFORMATION_MESSAGE, new ImageIcon("images/credit.gif"));
    	}
    	else if(btn == aboutUs)
    	{
    		JOptionPane.showMessageDialog(null,"Aplikasi ini dibuat oleh :\n1. Daniel Joi Partogi Hutapea (1107064)\n2. Firmando P. Siahaan (1107040)\n3. Windy (1107025)","About Us",JOptionPane.INFORMATION_MESSAGE, new ImageIcon("images/credit.gif"));
    	}
    		
    }
    
    //mengoveride interface MouseListener
    public void mouseClicked(MouseEvent e)
    {
    }
    
    public void mouseEntered(MouseEvent e)
    {
    	
    	Object obj = (Object) e.getSource();
    	
    	if(obj == theme[0])
    	{
    		theme[0].setRolloverIcon(new ImageIcon("images/3.gif"));
    		theme[0].setIcon(new ImageIcon("images/3.gif"));
    		theme[0].setSize(theme[0].getPreferredSize());
    		theme[0].setLocation(0,190);
    		fungsi.setText("Control JButton. Berfungsi untuk mengubah warna background & foreground \nJTextArea menjadi biru & putih.");
    	}
    	else if(obj == theme[1])
    	{
    		theme[0].setLocation(20,180);
    		theme[1].setRolloverIcon(new ImageIcon("images/3.gif"));
    		theme[1].setIcon(new ImageIcon("images/3.gif"));
    		theme[1].setSize(theme[1].getPreferredSize());
    		theme[1].setLocation(90,190);
    		fungsi.setText("Control JButton. Berfungsi untuk mengubah warna background & foreground \nJTextArea menjadi putih & hitam.");
    	}
    	else if(obj == theme[2])
    	{
    		theme[0].setLocation(20,180);
    		theme[1].setLocation(110,180);
    		theme[2].setRolloverIcon(new ImageIcon("images/3.gif"));
    		theme[2].setIcon(new ImageIcon("images/3.gif"));
    		theme[2].setSize(theme[2].getPreferredSize());
    		theme[2].setLocation(180,190);
    		fungsi.setText("Control JButton. Berfungsi untuk mengubah warna background & foreground \nJTextArea menjadi merah & hijau.");
    	}
    	else if(obj == theme[3])
    	{
    		theme[0].setLocation(20,180);
    		theme[1].setLocation(110,180);
    		theme[2].setLocation(200,180);
    		theme[3].setRolloverIcon(new ImageIcon("images/3.gif"));
    		theme[3].setIcon(new ImageIcon("images/3.gif"));
    		theme[3].setSize(theme[3].getPreferredSize());
    		theme[3].setLocation(273,190);
    		fungsi.setText("Control JButton. Berfungsi untuk mengubah warna background & foreground \nJTextArea menjadi hijau & merah.");
    	}
    	else if(obj == NewB)
    	{
    		fungsi.setText("Control JButton. Berfungsi untuk me-reset semua control.");
    	}
    	else if(obj == SaveB)
    	{
    		fungsi.setText("Control JButton. Berfungsi untuk meng-save text yang ada di JTextArea.");
    	}
    	else if(obj == LogOfB)
    	{
    		fungsi.setText("Control JButton. Berfungsi untuk meng-logoff komputer Anda.");
    	}
    	else if(obj == ShutdownB)
    	{
    		fungsi.setText("Control JButton. Berfungsi untuk meng-shutdown komputer Anda.");
    	}
    	else if(obj == RestartB)
    	{
    		fungsi.setText("Control JButton. Berfungsi untuk meng-restart komputer Anda.");
    	}
    	else if(obj == l1 || obj == l2 || obj == l3 || obj == lblFungsi)
    	{
    		fungsi.setText("Control JLabel.");
    	}
    	else if(obj == tf)
    	{
    		fungsi.setText("Control JTextField. Berfungsi sebagai tempat user mengetik nama hewan. User bisa memilih dari list yang tersedia kemudian tekan ENTER untuk autosearch.");
    	}
    	else if(obj == rb1)
    	{
    		fungsi.setText("Control JRadioButton. Berfungsi untuk menampilkan list hewan invertebrata di \nJComboBox. Akan di set-Enabled apabila JTextArea sudah diisi dan sebaliknya.");
    	}
    	else if(obj == rb2)
    	{
    		fungsi.setText("Control JRadioButton. Berfungsi untuk menampilkan list hewan vertebrata di \nJComboBox. Akan di set-Enabled apabila JTextArea sudah diisi dan sebaliknya.");
    	}
    	else if(obj == cb2)
    	{
    		fungsi.setText("Control JComboBox. Berfungsi untuk memilih sub kelas hewan yang diinginkan user.");
    	}
    	else if(obj == search)
    	{
    		fungsi.setText("Control JButton. Berfungsi untuk menampilkan info hewan di JTextArea.");
    	}
    	else if(obj == ta)
    	{
    		fungsi.setText("Control JTextArea. Berfungsi sebagai tempat menampilkan info hewan.");
    	}
    	else if(obj == credit)
    	{
    		fungsi.setText("Control JLabel. Berfungsi untuk menampilkan animasi tentang pembuat.");
    	}
    	else if(obj == image)
    	{
    		fungsi.setText("Control JLabel. Berfungsi untuk menampilkan gambar hewan yang dipilih user.");
    	}
    }
    
    public void mouseExited(MouseEvent e)
    {
    	Object obj = (Object) e.getSource();
    	
    	if(obj == theme[0])
    	{
    		theme[0].setIcon(null);
    		theme[0].setSize(theme[0].getPreferredSize());
    		theme[0].setLocation(33,180);
    	}
    	else if(obj == theme[1])
    	{
    		theme[0].setLocation(33,180);
    		theme[1].setIcon(null);
    		theme[1].setSize(theme[1].getPreferredSize());
    		theme[1].setLocation(123,180);
    	}
    	else if(obj == theme[2])
    	{
    		theme[0].setLocation(33,180);
    		theme[1].setLocation(123,180);
    		theme[2].setIcon(null);
    		theme[2].setSize(theme[2].getPreferredSize());
    		theme[2].setLocation(213,180);
    	}
    	else if(obj == theme[3])
    	{
    		theme[0].setLocation(33,180);
    		theme[1].setLocation(123,180);
    		theme[2].setLocation(213,180);
    		theme[3].setIcon(null);
    		theme[3].setSize(theme[3].getPreferredSize());
    		theme[3].setLocation(303,180);
    	}
    }
    
    public void mousePressed(MouseEvent e)
    {
    }
    
    public void mouseReleased(MouseEvent e)
    {
    }
    
    private void animasiClose()
    {
    	int x = this.getSize().width;
		int y = this.getSize().height;
        do
        {
			x--;
			y--;
			
			this.setSize(x,y);
			
			try
			{
				Thread.sleep(10);
			}
			catch(Exception ex)
			{
				
			}
		
			
		}
		while(x>=0 || y>=0);
    }
    
    private void animasiOpen()
    {
    	int x = 0;
		int y = 0;
        do
        {
			x++;
			y++;
			
			
			if(y>=510)
			{
				y = 510;	
			}
			this.setSize(x,y);
			
			try
			{
				Thread.sleep(10);
			}
			catch(Exception ex)
			{
			}
			
			
		}
		while(x<650);
		
    }
	
	public static void main(String args [])
	{
		new AnimalApp().showGUI();
		
	}
}